Index: java/main/src/main/java/com/framsticks/params/ReflectionAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 84)
@@ -4,14 +4,13 @@
 import java.lang.reflect.InvocationTargetException;
 import java.lang.reflect.Modifier;
-import java.lang.reflect.Type;
-import java.util.List;
 
-import com.framsticks.params.types.ListParam;
 import org.apache.log4j.Logger;
+
+import com.framsticks.util.lang.Containers;
 
 
 /**
  * The Class ReflectionAccess. Stores data in provided object using reflection.
- * 
+ *
  * @author Mateusz Jarus <name.surname@gmail.com> (please replace name and
  *         surname with my personal data)
@@ -20,13 +19,11 @@
  */
 public class ReflectionAccess extends SimpleAbstractAccess {
-	private final static Logger LOGGER = Logger.getLogger(ReflectionAccess.class
-			.getName());
+	private final static Logger log = Logger.getLogger(ReflectionAccess.class.getName());
 
-
-    protected final Class reflectedClass;
+	protected final Class<?> reflectedClass;
 	private Object object;
 
-	public ReflectionAccess(Class reflectedClass, FramsClass framsClass) {
-        this.reflectedClass = reflectedClass;
+	public ReflectionAccess(Class<?> reflectedClass, FramsClass framsClass) {
+		this.reflectedClass = reflectedClass;
 		setFramsClass(framsClass);
 	}
@@ -37,5 +34,5 @@
 
 	@Override
-	public <T> T get(Param param, Class<T> type) {
+	public <T> T get(ValueParam param, Class<T> type) {
 		if (object == null) {
 			return null;
@@ -54,29 +51,29 @@
 			} catch (InvocationTargetException e) {
 				//e.printStackTrace();
-            }
+			}
 
 		} catch (IllegalAccessException ex) {
-			LOGGER.warn("illegal access error occurred while trying to access returnedObject");
+			log.warn("illegal access error occurred while trying to access returnedObject");
 			ex.printStackTrace();
-        } catch (ClassCastException ignored) {
+		} catch (ClassCastException ignored) {
 
-        }
+		}
 		return null;
 	}
 
 	@Override
-	protected <T> void internalSet(Param param, T value) {
+	protected <T> void internalSet(ValueParam param, T value) {
 		setValue(param, value);
 	}
 
-	private <T> void setValue(Param param, T value) {
+	private <T> void setValue(ValueParam param, T value) {
 		if (object == null) {
 			return;
-        }
+		}
 		try {
 			String id = param.getId();
 			try {
 				Field f = reflectedClass.getField(id);
-				Class t = f.getType();
+				Class<?> t = f.getType();
 				if (Modifier.isFinal(f.getModifiers())) {
 					return;
@@ -111,5 +108,5 @@
 
 		try {
-			for (Param p : framsClass.getParamEntries()) {
+			for (ValueParam p : Containers.filterInstanceof(framsClass.getParamEntries(), ValueParam.class)) {
 				setValue(p, p.getDef(Object.class));
 			}
@@ -121,12 +118,13 @@
 	/**
 	 * Sets the new object to operate on.
-	 * 
+	 *
 	 * @param object
 	 *            new object to operate on
 	 */
 	@Override
-	public void select(Object object) {
+	public ReflectionAccess select(Object object) {
 		assert object == null || reflectedClass.isInstance(object);
 		this.object = object;
+		return this;
 	}
 
@@ -159,15 +157,15 @@
 	}
 
-    @Override
-    public Object createAccessee() {
-        try {
-            return reflectedClass.newInstance();
-        } catch (InstantiationException e) {
-            e.printStackTrace();
-        } catch (IllegalAccessException e) {
-            e.printStackTrace();
-        }
-        LOGGER.fatal("failed to create reflected object of class " + reflectedClass.getCanonicalName() + " for frams type " + framsClass.getId());
-        return null;
-    }
+	@Override
+	public Object createAccessee() {
+		try {
+			return reflectedClass.newInstance();
+		} catch (InstantiationException e) {
+			e.printStackTrace();
+		} catch (IllegalAccessException e) {
+			e.printStackTrace();
+		}
+		log.fatal("failed to create reflected object of class " + reflectedClass.getCanonicalName() + " for frams type " + framsClass.getId());
+		return null;
+	}
 }
Index: java/main/src/main/java/com/framsticks/params/Registry.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Registry.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/Registry.java	(revision 84)
@@ -10,7 +10,7 @@
  */
 public class Registry {
-	private static final Logger LOGGER = Logger.getLogger(Registry.class.getName());
+	private static final Logger log = Logger.getLogger(Registry.class.getName());
 
-	protected final Map<String, Class> reflectedClasses = new HashMap<String, Class>();
+	protected final Map<String, Class<?>> reflectedClasses = new HashMap<String, Class<?>>();
 	protected final Map<String, String> invertedReflectedClasses = new HashMap<String, String>();
 	protected final Map<String, FramsClass> infoCache = new HashMap<String, FramsClass>();
@@ -20,9 +20,10 @@
 			registerReflectedClass(name, id, Class.forName(className));
 		} catch (ClassNotFoundException e) {
-			LOGGER.fatal("class not found during registration: " + e);
+			log.fatal("class not found during registration: " + e);
 		}
 	}
 
-	public void registerReflectedClass(String name, String id, Class reflectedClass) {
+	public void registerReflectedClass(String name, String id,
+			Class<?> reflectedClass) {
 		if (name != null) {
 			reflectedClasses.put(name, reflectedClass);
@@ -43,8 +44,8 @@
 	public void putInfoIntoCache(FramsClass framsClass) {
 		if (infoCache.containsKey(framsClass.getId())) {
-			LOGGER.info("already cached " + framsClass);
+			log.info("already cached " + framsClass);
 			return;
 		}
-		LOGGER.debug("caching info for " + framsClass);
+		log.debug("caching info for " + framsClass);
 		infoCache.put(framsClass.getId(), framsClass);
 		infoCache.put(framsClass.getName(), framsClass);
@@ -63,3 +64,27 @@
 		return null;
 	}
+
+	public static AccessInterface wrapAccessWithListIfNeeded(CompositeParam param, AccessInterface access) {
+        if (access == null) {
+			return null;
+		}
+        return param.prepareAccessInterface(access);
+	}
+
+    public AccessInterface prepareAccess(CompositeParam param) {
+        return wrapAccessWithListIfNeeded(param, createAccess(param.getContainedTypeName()));
+    }
+
+	public AccessInterface createAccess(String name) {
+		if (name == null) {
+			return null;
+		}
+		FramsClass framsClass = getInfoFromCache(name);
+		if (framsClass == null) {
+			return null;
+		}
+
+		return createAccess(name, framsClass);
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 84)
@@ -2,13 +2,9 @@
 
 import java.io.IOException;
-import java.text.DecimalFormat;
-import java.text.DecimalFormatSymbols;
-import java.util.ArrayList;
 import java.util.Collection;
-import java.util.List;
-
-import com.framsticks.params.types.*;
+
+import static com.framsticks.util.lang.Containers.filterInstanceof;
+
 import org.apache.log4j.Logger;
-import java.util.Locale;
 
 /**
@@ -26,9 +22,7 @@
 public abstract class SimpleAbstractAccess implements AccessInterface {
 
-	private final static Logger LOGGER = Logger.getLogger(SimpleAbstractAccess.class.getName());
-
-
-
-    @Override
+	private final static Logger log = Logger.getLogger(SimpleAbstractAccess.class.getName());
+
+	@Override
 	public final FramsClass getFramsClass() {
 		return framsClass;
@@ -38,5 +32,5 @@
 		this.framsClass = framsClass;
 	}
-    /**
+	/**
 	 * Simple String key, value class.
 	 */
@@ -64,5 +58,5 @@
 	}
 
-    @Override
+	@Override
 	public int getParamCount() {
 		return framsClass.getParamCount();
@@ -71,12 +65,11 @@
 	@Override
 	public Param getParam(int i) {
-		return framsClass.getParamEntry(i);
+		return framsClass.getParamEntry(i, Param.class);
 	}
 
 	@Override
 	public Param getParam(String id) {
-		return framsClass.getParamEntry(id);
-	}
-
+		return framsClass.getParamEntry(id, Param.class);
+	}
 
 	@Override
@@ -87,53 +80,59 @@
 	@Override
 	public <T> T get(int i, Class<T> type) {
-		return get(getParam(i), type);
+		Param p = getParam(i);
+		assert p instanceof ValueParam;
+		return get((ValueParam) p, type);
 	}
 
 	@Override
 	public <T> T get(String id, Class<T> type) {
-		return get(getParam(id), type);
-	}
-
+		Param p = getParam(id);
+		assert p instanceof ValueParam;
+		return get((ValueParam) p, type);
+	}
 
 	@Override
 	public <T> int set(String id, T value) {
-		return set(getParam(id), value);
+		Param p = getParam(id);
+		assert p instanceof ValueParam;
+		return set((ValueParam) p, value);
 	}
 
 	@Override
 	public <T> int set(int i, T value) {
-		return set(getParam(i), value);
-	}
-
-	@SuppressWarnings("unchecked")
-	@Override
-	public <T> int set(Param param, T value) {
+		Param p = getParam(i);
+		assert p instanceof ValueParam;
+		return set((ValueParam) p, value);
+	}
+
+	@Override
+	public <T> int set(ValueParam param, T value) {
 		int flags = 0;
+
 		//String id = param.getEffectiveId();
 		try {
-            Object oldValue = get(param, param.getStorageType());
-            Object casted = param.reassign(value, oldValue);
-            if (casted != oldValue) {
-                internalSet(param, casted);
-            }
-        } catch (CastFailure e) {
-            LOGGER.error("casting failure while set: ", e);
-
-        }
-        return flags;
-    }
-
-
-
+			Object oldValue = get(param, param.getStorageType());
+			ReassignResult<?> result = param.reassign(value, oldValue);
+			Object casted = result.getValue();
+			if (casted != oldValue) {
+				internalSet(param, casted);
+			}
+			flags = result.getFlags();
+		} catch (CastFailure e) {
+			log.error("casting failure while set: ", e);
+		}
+		return flags;
+	}
 
 	@Override
 	public void setDefault(boolean numericOnly) {
-		for (int i = 0; i < framsClass.getParamCount(); i++)
+		for (int i = 0; i < framsClass.getParamCount(); i++) {
 			setDefault(i, numericOnly);
+		}
 	}
 
 	@Override
 	public void setDefault(int i, boolean numericOnly) {
-		Param entry = framsClass.getParamEntry(i);
+		ValueParam entry = framsClass.getParamEntry(i, ValueParam.class);
 		if ((entry != null)	&& (!numericOnly || entry.isNumeric())) {
 			set(i, entry.getDef(entry.getStorageType()));
@@ -148,8 +147,10 @@
 	}
 
-	@SuppressWarnings("unchecked")
 	@Override
 	public void setMin(int i) {
-		Param entry = framsClass.getParamEntry(i);
+		PrimitiveParam entry = framsClass.getParamEntry(i, PrimitiveParam.class);
+		if (entry == null) {
+			return;
+		}
 		Object min = entry.getMin(entry.getStorageType());
 		if (min != null) {
@@ -165,8 +166,10 @@
 	}
 
-	@SuppressWarnings("unchecked")
 	@Override
 	public void setMax(int i) {
-		Param entry = framsClass.getParamEntry(i);
+		PrimitiveParam entry = framsClass.getParamEntry(i, PrimitiveParam.class);
+		if (entry == null) {
+			return;
+		}
 		Object max = entry.getMax(entry.getStorageType());
 		if (max != null) {
@@ -191,169 +194,99 @@
 	@Override
 	public void save(SinkInterface sink) {
-        assert framsClass != null;
-        sink.print(framsClass.getId()).print(":").breakLine();
-        for (Param p : framsClass.getParamEntries()) {
-            if (p instanceof ValueParam) {
-                Object value = get(p, Object.class);
-                if (value == null) {
-                    continue;
-                }
-                sink.print(p.getId()).print(":");
-                ((ValueParam)p).save(sink, value);
-                sink.breakLine();
-
-
-                //continue;
-            }
-            /*
-            if (p instanceof CompositeParam) {
-                if (!(p instanceof ListParam)) {
-                    continue;
-                }
-                Collection c = get(p, Collection.class);
-                if (c != null) {
-                    save(stream, p, c.size());
-                }
-            }
-            */
-
-        }
-        sink.breakLine();
-	}
-
-	@Override
-	public String save2(boolean omitDefaultValues) {
-		StringBuilder stringBuilder = new StringBuilder();
-		DecimalFormat df = new DecimalFormat("#.###", new DecimalFormatSymbols(
-				Locale.ENGLISH));
-		boolean canOmitName = false;
-		int n = 0;
-		for (int i = 0; i < framsClass.getParamCount(); i++) {
-			Object value = this.get(i, Object.class);
-			Object def = framsClass.getParamEntry(i).getDef(Object.class);
-			if (value != null && (!omitDefaultValues || !value.equals(def))) {
-				if ((n != i && !canOmitName)
-						|| (getParam(i).getFlags() & Flags.CANOMITNAME) == 0) {
-					stringBuilder.append(getParam(i).getId());
-					stringBuilder.append("=");
+		assert framsClass != null;
+		sink.print(framsClass.getId()).print(":").breakLine();
+		for (PrimitiveParam p : filterInstanceof(framsClass.getParamEntries(), PrimitiveParam.class)) {
+			Object value = get(p, Object.class);
+			if (value == null) {
+				continue;
+			}
+			sink.print(p.getId()).print(":");
+			p.save(sink, value);
+			sink.breakLine();
+		}
+		sink.breakLine();
+	}
+
+	private Entry readEntry(SourceInterface source)
+			throws IOException {
+
+		String line;
+		String key = null;
+		StringBuilder value = null;
+		while ((line = source.readLine()) != null)
+		{
+			if (key == null) {
+				int colonIndex = line.indexOf(':');
+				if (colonIndex == -1) {
+					return null;
 				}
-				n++;
-				canOmitName = true;
-				if (this.get(i, Object.class) instanceof String) {
-					String valueString = this.get(i, String.class);
-					valueString = valueString.replaceAll("\\\"", "\\\\\"");
-					valueString = valueString.contains(",") ? "\""
-							+ valueString + "\"" : valueString;
-					// if ("".equals(valueString.trim()))
-					// value = "\"\"";
-					stringBuilder.append(valueString);
-				} else if (this.get(i, Object.class) instanceof Double) {
-					stringBuilder.append(df.format(this.get(i, Double.class)));
-				} else
-					stringBuilder.append(this.get(i, Object.class));
-				stringBuilder.append(", ");
+				key = line.substring(0, colonIndex);
+				String inlineValue = line.substring(colonIndex + 1);
+
+
+				if (!inlineValue.startsWith("~")) {
+					return new Entry(key, inlineValue);
+				}
+				value = new StringBuilder();
+				value.append(inlineValue.substring(1));
+				continue;
+			}
+			if (value.length() != 0) {
+				value.append(System.getProperty("line.separator"));
+			}
+			if (line.contains("~")) {
+				value.append(line.substring(0, line.indexOf("~")));
+				return new Entry(key, value.toString());
+			}
+			value.append(line);
+			/*
+			if (line.contains("~")) {
+				String lastLine = line.substring(0, line.indexOf("~"));
+				if (lastLine.length() > 0) {
+					appendToValue(value, lastLine);
+				}
+				return new Entry(key, value.toString());
+			}
+			appendToValue(value, line);
+			*/
+		}
+		return null;
+	}
+
+	@Override
+	public void load(SourceInterface source) throws Exception {
+		//TODO not clearing values, because get from manager gives only fields, not children
+		//this.clearValues();
+
+		Entry entry;
+		while ((entry = readEntry(source)) != null) {
+			Param param = getParam(entry.key);
+			if (param == null) {
+				continue;
+			}
+			if (!(param instanceof ValueParam)) {
+				log.warn("param " + param + " is not a ValueParam");
+				continue;
+			}
+			if ((param.getFlags() & Flags.DONTLOAD) != 0) {
+				log.debug("DontLoad flag was set - not loading...");
 			} else {
-				canOmitName = false;
-			}
-		}
-
-		String params = "";
-		if (stringBuilder.length() > 1)
-			params = stringBuilder.substring(0, stringBuilder.length() - 2);
-
-		return getId() + ":" + params;
-	}
-
-    /*
-    private static void appendToValue(StringBuilder value, String line) {
-
-        if (value.length() != 0) {
-            value.append(System.getProperty("line.separator"));
-        }
-        value.append(line);
-    }
-    */
-
-    private Entry readEntry(SourceInterface source)
-            throws IOException {
-
-        String line;
-        String key = null;
-        StringBuilder value = null;
-        while ((line = source.readLine()) != null)
-        {
-            if (key == null) {
-                int colonIndex = line.indexOf(':');
-                if (colonIndex == -1) {
-                    return null;
-                }
-                key = line.substring(0, colonIndex);
-                String inlineValue = line.substring(colonIndex + 1);
-
-
-                if (!inlineValue.startsWith("~")) {
-                    return new Entry(key, inlineValue);
-                }
-                value = new StringBuilder();
-                value.append(inlineValue.substring(1));
-                continue;
-            }
-            if (value.length() != 0) {
-                value.append(System.getProperty("line.separator"));
-            }
-            if (line.contains("~")) {
-                value.append(line.substring(0, line.indexOf("~")));
-                return new Entry(key, value.toString());
-            }
-            value.append(line);
-            /*
-            if (line.contains("~")) {
-                String lastLine = line.substring(0, line.indexOf("~"));
-                if (lastLine.length() > 0) {
-                    appendToValue(value, lastLine);
-                }
-                return new Entry(key, value.toString());
-            }
-            appendToValue(value, line);
-            */
-        }
-        return null;
-    }
-
-    @Override
-    public void load(SourceInterface source) throws Exception {
-        //TODO not clearing values, because get from manager gives only fields, not children
-        //this.clearValues();
-
-        Entry entry;
-        while ((entry = readEntry(source)) != null) {
-            Param param = getParam(entry.key);
-            if (param == null) {
-                continue;
-            }
-            if ((param.getFlags() & Flags.DONTLOAD) != 0) {
-                LOGGER.debug("DontLoad flag was set - not loading...");
-            } else {
-                int retFlags = this.set(param, entry.value);
-                if ((retFlags & (Flags.PSET_HITMIN | Flags.PSET_HITMAX)) != 0) {
-                    String which = ((retFlags & Flags.PSET_HITMIN) != 0) ? "small"
-                            : "big";
-                    LOGGER.warn("value of key '" + entry.key
-                            + "' was too " + which + ", adjusted");
-                }
-            }
-        }
-    }
-
-
-
-	protected abstract <T> void internalSet(Param param, T value);
-
-    @Override
-    public Collection<Param> getParams() {
-        return framsClass.getParamEntries();
-    }
-
-    /*
+				int retFlags = this.set((ValueParam) param, entry.value);
+				if ((retFlags & (Flags.PSET_HITMIN | Flags.PSET_HITMAX)) != 0) {
+					String which = ((retFlags & Flags.PSET_HITMIN) != 0) ? "small" : "big";
+					log.warn("value of key '" + entry.key + "' was too " + which + ", adjusted");
+				}
+			}
+		}
+	}
+
+	protected abstract <T> void internalSet(ValueParam param, T value);
+
+	@Override
+	public Collection<Param> getParams() {
+		return framsClass.getParamEntries();
+	}
+
+	/*
 	protected <T extends Comparable<T>> int setAndCut(Param param, Object value, Class<T> type) {
 		int flags = 0;
Index: java/main/src/main/java/com/framsticks/params/UniqueListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 84)
@@ -1,6 +1,6 @@
 package com.framsticks.params;
 
-import com.framsticks.util.Casting;
-import com.framsticks.util.Numbers;
+import com.framsticks.util.lang.Casting;
+import com.framsticks.util.lang.Numbers;
 import org.apache.log4j.Logger;
 
@@ -12,181 +12,184 @@
 public class UniqueListAccess extends ListAccess {
 
-    private static final Logger LOGGER = Logger.getLogger(UniqueListAccess.class.getName());
+	private static final Logger log = Logger.getLogger(UniqueListAccess.class.getName());
 
-    Map<String, Object> map;
+	Map<String, Object> map;
 
-    final String uidName;
+	final String uidName;
 
-    public UniqueListAccess(AccessInterface elementAccess, String uidName) {
-        super(elementAccess);
-        this.uidName = uidName;
-    }
+	public UniqueListAccess(AccessInterface elementAccess, String uidName) {
+		super(elementAccess);
+		this.uidName = uidName;
+	}
 
-    @Override
-    public Map<String, Object> createAccessee() {
-        return new HashMap<String, Object>();
-    }
+	@Override
+	public Map<String, Object> createAccessee() {
+		return new HashMap<String, Object>();
+	}
 
-    @Override
-    public Param getParam(int i) {
-        LOGGER.error("accesing unique list through index");
-        assert false;
-        return null;
-        //LOGGER.error("accesing unique list through index");
-        //return null;
-        //return new ParamBuilder().setId(Integer.toString(i)).setName(elementAccess.getId()).setType("o " + elementAccess.getId()).build();
-    }
+	@Override
+	public Param getParam(int i) {
+		log.error("accesing unique list through index");
+		assert false;
+		return null;
+		//log.error("accesing unique list through index");
+		//return null;
+		//return new ParamBuilder().setId(Integer.toString(i)).setName(elementAccess.getId()).setType("o " + elementAccess.getId()).build();
+	}
 
-    @Override
-    public Param getParam(String id) {
-        Integer i = Numbers.parse(id, Integer.class);
-        if (i != null) {
-            return getParam(i);
-        }
-        return new ParamBuilder().setId(id).setName(elementAccess.getId()).setType("o " + elementAccess.getId()).build();
-    }
+	@Override
+	public Param getParam(String id) {
+		Integer i = Numbers.parse(id, Integer.class);
+		if (i != null) {
+			return getParam(i);
+		}
+		return new ParamBuilder().setId(id).setName(elementAccess.getId()).setType("o " + elementAccess.getId()).build();
+	}
 
-    @Override
-    public String getId() {
-        return "l " + elementAccess.getId() + " " + uidName;
-    }
+	@Override
+	public String getId() {
+		return "l " + elementAccess.getId() + " " + uidName;
+	}
 
-    @Override
-    public int getParamCount() {
-        return map.size();
-    }
+	@Override
+	public int getParamCount() {
+		return map.size();
+	}
 
-    @Override
-    public <T> T get(int i, Class<T> type) {
-        LOGGER.error("accesing unique list through index");
-        assert false;
-        return null;
-        //Object[] values = map.values().toArray();
-        //return Casting.tryCast(i < values.length ? values[i] : null, type);
-    }
+	@Override
+	public <T> T get(int i, Class<T> type) {
+		log.error("accesing unique list through index");
+		assert false;
+		return null;
+		//Object[] values = map.values().toArray();
+		//return Casting.tryCast(i < values.length ? values[i] : null, type);
+	}
 
-    @Override
-    public <T> T get(String id, Class<T> type) {
-        Integer i = Numbers.parse(id, Integer.class);
-        if (i != null) {
-            return get(i, type);
-        }
-        return Casting.tryCast(type, map.containsKey(id) ? map.get(id) : null);
-    }
+	@Override
+	public <T> T get(String id, Class<T> type) {
+		Integer i = Numbers.parse(id, Integer.class);
+		if (i != null) {
+			return get(i, type);
+		}
+		return Casting.tryCast(type, map.containsKey(id) ? map.get(id) : null);
+	}
 
-    @Override
-    public <T> T get(Param param, Class<T> type) {
-        return get(param.getId(), type);
-    }
+	@Override
+	public <T> T get(ValueParam param, Class<T> type) {
+		return get(param.getId(), type);
+	}
 
-    public String getUidOf(Object value) {
-        Object tmp = elementAccess.getSelected();
-        elementAccess.select(value);
-        String uid = elementAccess.get(uidName, String.class);
-        elementAccess.select(tmp);
-        if (uid == null) {
-            return null;
-        }
-        return uid;
-    }
+	public String getUidOf(Object value) {
+		Object tmp = elementAccess.getSelected();
+		elementAccess.select(value);
+		String uid = elementAccess.get(uidName, String.class);
+		elementAccess.select(tmp);
+		if (uid == null) {
+			return null;
+		}
+		return uid;
+	}
 
-    protected int setByUid(Object object, String uid) {
-        if (uid == null) {
-            uid = getUidOf(object);
-            if (uid == null) {
-                LOGGER.error("failed to set - missing uid");
-                return 0;
-            }
-        }
-        if (object == null) {
-            map.remove(uid);
-        } else {
-            map.put(uid, object);
-        }
-        return 0;
-    }
+	protected int setByUid(Object object, String uid) {
+		if (uid == null) {
+			uid = getUidOf(object);
+			if (uid == null) {
+				log.error("failed to set - missing uid");
+				return 0;
+			}
+		}
+		if (object == null) {
+			map.remove(uid);
+		} else {
+			map.put(uid, object);
+		}
+		return 0;
+	}
 
-    @Override
-    public <T> int set(int i, T value) {
-        LOGGER.error("accesing unique list through index");
-        //return setByUid(value, null);
-        return 0;
-    }
+	@Override
+	public <T> int set(int i, T value) {
+		log.error("accesing unique list through index");
+		//return setByUid(value, null);
+		return 0;
+	}
 
-    @Override
-    public <T> int set(String id, T value) {
-        Integer i = Numbers.parse(id, Integer.class);
-        if (i != null) {
-            return set(i, value);
-        }
-        if (value == null) {
-            return setByUid(null, id);
-        }
-        String uid = getUidOf(value);
-        if (uid != null && id != null) {
-            if (!id.equals(uid)) {
-                LOGGER.error("uid mismatch with set key");
-                return 0;
-            }
-            setByUid(value, uid);
-            return 0;
-        }
-        if (uid != null) {
-            setByUid(value, uid);
-            return 0;
-        }
-        if (id != null) {
-            setByUid(value, id);
-            return 0;
-        }
-        LOGGER.error("missing both uid and id - failed to set");
-        return 0;
-    }
+	@Override
+	public <T> int set(String id, T value) {
+		Integer i = Numbers.parse(id, Integer.class);
+		if (i != null) {
+			return set(i, value);
+		}
+		if (value == null) {
+			return setByUid(null, id);
+		}
+		String uid = getUidOf(value);
+		if (uid != null && id != null) {
+			if (!id.equals(uid)) {
+				log.error("uid mismatch with set key");
+				return 0;
+			}
+			setByUid(value, uid);
+			return 0;
+		}
+		if (uid != null) {
+			setByUid(value, uid);
+			return 0;
+		}
+		if (id != null) {
+			setByUid(value, id);
+			return 0;
+		}
+		log.error("missing both uid and id - failed to set");
+		return 0;
+	}
 
-    @Override
-    public <T> int set(Param param, T value) {
-        return set(param.getId(), value);
-    }
+	@Override
+	public <T> int set(ValueParam param, T value) {
+		return set(param.getId(), value);
+	}
 
-    @Override
-    public void clearValues() {
-        map.clear();
-    }
+	@Override
+	public void clearValues() {
+		map.clear();
+	}
 
-    @Override
-    public void select(Object object) {
-        map = (Map<String, Object>)object;
-    }
+	@SuppressWarnings("unchecked")
+	@Override
+	public UniqueListAccess select(Object object) {
+		assert (object instanceof Map);
+		map = (Map<String, Object>) object;
+		return this;
+	}
 
-    @Override
-    public Object getSelected() {
-        return map;
-    }
+	@Override
+	public Object getSelected() {
+		return map;
+	}
 
-    @Override
-    public UniqueListAccess cloneAccess() {
-        return new UniqueListAccess(elementAccess.cloneAccess(), uidName);
-    }
+	@Override
+	public UniqueListAccess cloneAccess() {
+		return new UniqueListAccess(elementAccess.cloneAccess(), uidName);
+	}
 
-    @Override
-    public String computeIdentifierFor(Object selected) {
-        String uid = getUidOf(selected);
-        if (uid == null) {
-            LOGGER.error("missing uid field");
-            return null;
-        }
-        return uid;
-    }
+	@Override
+	public String computeIdentifierFor(Object selected) {
+		String uid = getUidOf(selected);
+		if (uid == null) {
+			log.error("missing uid field");
+			return null;
+		}
+		return uid;
+	}
 
-    @Override
-    public Collection<Param> getParams() {
-        List<Param> result = new LinkedList<Param>();
-        if (map == null) {
-            return result;
-        }
-        for (String k : map.keySet()) {
-            result.add(getParam(k));
-        }
-        return result;
-    }
+	@Override
+	public Collection<Param> getParams() {
+		List<Param> result = new LinkedList<Param>();
+		if (map == null) {
+			return result;
+		}
+		for (String k : map.keySet()) {
+			result.add(getParam(k));
+		}
+		return result;
+	}
 }
Index: java/main/src/main/java/com/framsticks/params/Util.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Util.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/Util.java	(revision 84)
@@ -4,17 +4,21 @@
 import java.util.List;
 
+import static com.framsticks.util.lang.Containers.filterInstanceof;
+
 /**
  * @author Piotr Sniegowski
  */
 public abstract class Util {
-    public static String readSourceToString(SourceInterface source) {
-        StringBuilder result = new StringBuilder();
-        String line;
-        while ((line = source.readLine()) != null) {
-            result.append(line).append(" ");
-        }
-        source.close();
-        return result.toString();
-    }
+
+	public static String readSourceToString(SourceInterface source) {
+		StringBuilder result = new StringBuilder();
+		String line;
+		while ((line = source.readLine()) != null) {
+			result.append(line).append(" ");
+		}
+		source.close();
+		return result.toString();
+	}
+
 	public static List<Object> stripAccessInterface(List<AccessInterface> accesses) {
 		List<Object> result = new ArrayList<Object>();
@@ -24,9 +28,10 @@
 		return result;
 	}
+
 	public static int copyParams(AccessInterface to, AccessInterface from) {
 		int copied = 0;
-		for (Param f : from.getParams()) {
+		for (ValueParam f : filterInstanceof(from.getParams(), ValueParam.class)) {
 			Param t = from.getParam(f.getId());
-			if (t == null) {
+			if (!(t instanceof ValueParam)) {
 				continue;
 			}
@@ -34,5 +39,5 @@
 				continue;
 			}
-			to.set(t, from.get(f, Object.class));
+			to.set((ValueParam) t, from.get(f, Object.class));
 			++copied;
 		}
Index: java/main/src/main/java/com/framsticks/params/ValueParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ValueParam.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/params/ValueParam.java	(revision 84)
@@ -0,0 +1,15 @@
+package com.framsticks.params;
+
+
+/**
+ * @author Piotr Sniegowski
+ */
+public abstract class ValueParam extends Param {
+
+	public ReassignResult<?> reassign(Object newValue, Object oldValue) throws CastFailure {
+		throw new CastFailure();
+	}
+
+	public abstract <T> T getDef(Class<T> type) throws ClassCastException;
+
+}
